#!/usr/bin/python3
#-*- coding: utf-8 -*-

# Classe venant de tyrtamos ... à voir ici :
# https://www.developpez.net/forums/d1117521-2/autres-langages/
# python-zope/general-python/tester-fonction-return-ete-executee

import functools

class nbre_appel_fonction(object) :

    def __init__(self, fonc) :
        """ Décorateur qui stocke les résultats 
        d'appels des fonctions décorées """
        
        self.fonc = fonc
        functools.wraps(fonc)(self)
        self.nbappels = 0
        self.resultats = {}

    def __call__(self, *args, **kwargs) :
        """ Méthode appelée à chaque 
        appel de la fonction décorée """
        
        result = self.fonc(*args, **kwargs)
        self.nbappels += 1
        self.resultats[self.nbappels] = result
        return result
    

