#!/usr/bin/python3
#-*- coding: utf-8 -*-

#-------------------------------------------------------------------------------
# Author:      Lama Angelo
#
# Copyright:   (c) Lama Angelo 2021
#-------------------------------------------------------------------------------

# Imports PyQt5 ----------------------------------------------------------------
from PyQt5.QtGui import QFont, QFontDatabase, QIcon
# ------------------------------------------------------------------------------

def fonte(widget, famille, style, taille) :
    ''' Fonction générique d'attribution de la fonte, 
    par exemple dans le QTextWidget de démonstration 
    contenu dans le module selection_police.py '''

    f = QFont()
    # Attribution du type de fonte
    f.setFamily(famille)
    # ---------------------
    # Attribue les styles
    if style == 'Bold' : f.setBold(True)
    if style == 'Italic' : f.setItalic(True)
    # ---------------------
    # Là je sais pas ... à voir
    f.setFixedPitch(True)
    # Attribue la taille
    f.setPointSize(int(taille))
    # On passe la fonte au widget
    widget.setFont(f)
    
